from django.contrib.gis import admin
from adminShapes.models import Area, Place, City, ShapeFileZip
from django.conf.urls import patterns
from django.template import Context, loader
from django.http import HttpResponse
from django.contrib import messages



class AreaOSMAdmin(admin.OSMGeoAdmin):
    #filters
    list_display = ('name', 'city')
    
  
class PlaceOSMAdmin(admin.OSMGeoAdmin):
    #filters
    list_display = ('url', 'city', 'area')
    
    #overiding the saving method
    #first, check if the Google Street View image exist and then save it
    def save_model(self, request, obj, form, change):
        try:
            obj.deletePhoto()
        except Exception: 
            pass
        finally:   
            messages.set_level(request, messages.ERROR)
            obj.url = "http://maps.googleapis.com/maps/api/streetview?size=400x400&location="+str(obj.point.y)+",%20"+str(obj.point.x)+"&sensor=false&key=AIzaSyBTdISjiOW54zc95uWK4sQYtZWOJlivio0"
        
            if (obj.cache()==False):
                #if it isn't found, displays a error message
                messages.error(request, "Google Street View not found.")
            else:
                messages.set_level(request, messages.INFO) 
    


admin.site.register(City, admin.OSMGeoAdmin)
admin.site.register(Area, AreaOSMAdmin)
admin.site.register(Place, PlaceOSMAdmin)
