function showhideModel(){
	if ($("#modelMenu").is(":visible")){
		$("#modelMenu").hide();	
	} else {
		$("#modelMenu").show();
	}
}

function callSaveShapefile(path,city){
	Dajaxice.adminShapes.saveShapefile(callbackSavesShp, {'data': [$('#fields-left').val(),path,city]});
}

function callSaveExistingShapefile(path,city){
	Dajaxice.adminShapes.saveExistingShapefile(callbackSavesExistingShp, {'data': [$('#fields-left').val(),path,city]});
}

function callbackSavesExistingShp(data){
	alert(data.message)
}

function initCreateCity(data){
	$('#city').change(function() {
		//check if the area is already created
		if(data.indexOf($('#city').val())>0){
			alert ("The city already exist, you will overide it")
		}
	});
}

function callbackSavesShp(data){
	$("#fromPost").hide();
	$("#fields-left").hide();
	$("#pbtn").hide();
	$("#nextPost").show();
	$("#getg").show();
	$("#pgetg").show();
	//create 2 maps, one for the whole city and one for the areas
	createMap(data["polyArea"],data["nameArea"],'mapArea');
	createMap(data["polyCity"],data["nameCity"],'mapCity');	
}

function createMap(areas,names,mapName){
	//projection conversion
	var espg13Proj = new OpenLayers.Projection("EPSG:900913");
	var espg4326Proj = new OpenLayers.Projection("EPSG:4326");
	
	//create a map without controls (no zoom, no movement)
	map = new OpenLayers.Map( mapName , { controls : [] } );
	
	//layer for the OpenStreetMap            
	var osmLayer = new OpenLayers.Layer.OSM();
	map.addLayer(osmLayer);

	//vectors layer have the polygons
    vectors = new OpenLayers.Layer.Vector("Vector Layer");

	//read the wkt imput type (POLYGON(54.3436,43.435...))
    wkt = new OpenLayers.Format.WKT();
    
    //areas is the textfield where we have saved the areas
    for (var i in areas){
    	var features = wkt.read(areas[i]);
		features.attributes = {
				            name: names[i],
			                favColor: 'blue',
			                align: 'cm'
		};
		//The points in the database aren't in the map projection,
		//we have to transform them
		features.geometry.transform(espg4326Proj,espg13Proj);
	    vectors.addFeatures([features]);
	}
	//zoom set on the whole vector extension
	map.zoomToExtent(vectors.getDataExtent());
    
    //add the layer to the map
	map.addLayer(vectors);
	
	//event that displays the name of the feature
	vectors.events.register("featureselected", vectors, function selected (evt) {
			document.getElementById(mapName.concat("Div")).innerHTML = evt.feature.attributes.name;
		});
                
	var control = new OpenLayers.Control.SelectFeature(vectors, {
                	hover: true,
                	});
	                
	            
	            
	map.addControl(control);
	control.activate();
		
}

var pointsOfInterest = []

//function that generate the easy-to-guess points
function initEtg(names,areas){
	
	var espg13Proj = new OpenLayers.Projection("EPSG:900913");
	var espg4326Proj = new OpenLayers.Projection("EPSG:4326");
	
	map = new OpenLayers.Map( 'map' , { controls : [] } );
	            

	var osmLayer = new OpenLayers.Layer.OSM();
	map.addLayer(osmLayer);

	vectors = new OpenLayers.Layer.Vector("Vector Layer");

	wkt = new OpenLayers.Format.WKT();
                
	            
	for (var i in areas){
    	
		var features = wkt.read(areas[i]);
		features.attributes = {
				            name: names[i],
			                favColor: 'blue',
			                align: 'cm'
		};
		features.geometry.transform(espg4326Proj,espg13Proj);
	    vectors.addFeatures([features]);
	}
	map.zoomToExtent(vectors.getDataExtent());
                
	map.addLayer(vectors);
	
	
	var centerPoint = map.getCenter();
		      	
		      	
	centerPoint.transform(espg13Proj,espg4326Proj);
		      	
	//set location of center
	var googleLoc = new google.maps.LatLng(centerPoint.lat,centerPoint.lon);
				
	//radius that we want for the map
	var googleZoom = Math.abs(vectors.getDataExtent().top - vectors.getDataExtent().bottom);
				
	//initialize the map
	mapGoogle = new google.maps.Map(document.getElementById('googleMap'), {
				      mapTypeId: google.maps.MapTypeId.ROADMAP,
				      center: googleLoc,
				      zoom: 15
				    });
	
	//request options
	var request = {
				    location: googleLoc,
				    radius: googleZoom,
				    types: ['zoo','synagogue','stadium','shopping_mall','university',
				    'courthouse','fire_station','hindu_temple','local_government_office',
				    'mosque','hospital','establishment','museum','airport','amusement_park',
				    'aquarium','park','art_gallery','cemetery','church','city_hall']
				  };
				
	//make the request
	service = new google.maps.places.PlacesService(mapGoogle);
	service.nearbySearch(request, callbackGoogle);
}

function initGRP(areas,names,city,type,drop){
	createMapRandomPoints(areas,names,'map');
	generateRandomPoints(city,type,drop);
}

var map;

function createMapRandomPoints(areas,names,mapName){

	var espg13Proj = new OpenLayers.Projection("EPSG:900913");
	var espg4326Proj = new OpenLayers.Projection("EPSG:4326");
	
	map = new OpenLayers.Map( mapName , { controls : [] } );
	            
	var osmLayer = new OpenLayers.Layer.OSM();
	map.addLayer(osmLayer);

    vectors = new OpenLayers.Layer.Vector("Vector Layer");

    wkt = new OpenLayers.Format.WKT();
    
    for (var i in areas){
		var features = wkt.read(areas[i]);
		features.attributes = {
				            name: names[i],
			                favColor: 'blue',
			                align: 'cm'
		};
		features.geometry.transform(espg4326Proj,espg13Proj);
	    vectors.addFeatures([features]);
	}
	map.zoomToExtent(vectors.getDataExtent());
    
	map.addLayer(vectors);
	
	pointsLayer  = new OpenLayers.Layer.Vector("Point Layer");
                
    map.addLayer(pointsLayer);
	
	/*vectors.events.register("featureselected", vectors, function selected (evt) {
				document.getElementById(mapName.concat("Div")).innerHTML = evt.feature.attributes.name;
		});*/
                
	var control = new OpenLayers.Control.SelectFeature(vectors, {
                	hover: true,
                	});
	                
	            
	            
	map.addControl(control);
	control.activate();		
}


function hide(){
	$("#fromPost").hide();
}

function hide(){
	$("#fromPost").hide();
	$("#cityOptions").hide();
	$("#dropPrevious").hide();
}

//this function is called as a callback of the google request
//it adds the checkboxes with the name and the images in the select 
function callbackGoogle(results, status){
	if (status == google.maps.places.PlacesServiceStatus.OK) {
		for (var i = 0; i < results.length; i++){
			var place = results[i];
			pointsOfInterest.push(place);
			
			//create the variables
      		var url = "http://maps.googleapis.com/maps/api/streetview?size=400x400&location="+results[i].geometry.location.jb.toFixed(10)+",%20"+results[i].geometry.location.kb.toFixed(10)+"&sensor=false&key=AIzaSyBTdISjiOW54zc95uWK4sQYtZWOJlivio0";
			var label= document.createElement("label");
			var description = document.createTextNode(place.name);
			var checkbox = document.createElement("input");
			var img = document.createElement("img")
			
			//create the checkbox
			checkbox.type = "checkbox";
			checkbox.name = "slct[]";
			checkbox.value = place.name
			
			//create the image
			img.src=url;
			
			//create the label
			label.setAttribute("class","checkbox inline")
			label.appendChild(img);
			label.appendChild(document.createElement("br"));
			label.appendChild(checkbox);
			label.appendChild(description);
			label.appendChild(document.createElement("br"));

			//add everything to the checkbox
			document.getElementById('checkbox').appendChild(label);
	  	}
  	}
}

//this function saves the points that have been selected by the user
function saveETG(city){
	var count = $('#checkbox')[0].childElementCount;
	for (var i=0;i<count;i++){
		if (document.getElementById('checkbox').childNodes[i].childNodes[2].checked){
			var pointjb = pointsOfInterest[i].geometry.location.jb.toFixed(10);
			var pointkb = pointsOfInterest[i].geometry.location.kb.toFixed(10);
				Dajaxice.adminShapes.generateImage(function callback(data){}, {'data':[pointjb,pointkb,city]})
		}
	}
	$("#checkbox").hide();
	$("#divSaveETG").hide();
	$("#grPost").show();
}

function generateRandomPoints(city,type,drop){
	var points = document.getElementById('npoints').value;
	Dajaxice.adminShapes.generateRandomPoints(callbackRandomPoints, {'data':[points,city,type,drop]});
}

//this function displays the points that have been saved in the map
function callbackRandomPoints(data){
	var toProjection = new OpenLayers.Projection("EPSG:900913");
  	var fromProjection = new OpenLayers.Projection("EPSG:4326");
  	//read the points
	var points = data.message.substring(2).split("AA");
	//deletes the previous points
	map.removeLayer(pointsLayer);
	pointsLayer  = new OpenLayers.Layer.Vector("Point Layer");
	map.addLayer(pointsLayer);
	//the points are orange with a black stroke
	var point_style = OpenLayers.Util.extend(
	    {},
	    OpenLayers.Feature.Vector.style['default']
	);
    point_style.graphicOpacity = 1;
    point_style.pointRadius = 3;
    point_style.fillColor = "#ffa500";
    point_style.fillOpacity = 0.4;
    point_style.strokeColor = "#000011";
    point_style.strokeWidth = 2;
    point_style.strokeLinecap = "butt";
    //add each point to the points layer
	for (var i in points){
		var pointJ = points[i].split(",");
		tmpPoint = new OpenLayers.Geometry.Point(pointJ[1],pointJ[0]);
		tmpPoint.transform(fromProjection, toProjection);
		pointsLayer.addFeatures(new OpenLayers.Feature.Vector(tmpPoint,null,point_style));
	}
}

function initImportShapefile(cities){
	list = cities;
	for (var i in list){
		var o = new Option(list[i], list[i]);
		$(o).html(list[i]);
		$('#cityOptions').append(o);
	}
}

function initGeneratePoints(cities){
	list = cities;
	for (var i in list){
		var o = new Option(list[i], list[i]);
		$(o).html(list[i]);
		$('#cityOptions').append(o);
	}
}

